/* $Id: SpecProviderList.java,v 1.1 2005/03/31 05:40:03 sgalles Exp $
 * -----------------------------------------------------------------------
 * 
 * TSP Library - core components for a generic Transport Sampling Protocol.
 * 
 * Copyright (c) 2002 Yves DUFRENNE, Stephane GALLES, Eric NOULARD and Robert PAGNOT 
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * -----------------------------------------------------------------------
 * 
 * Project    : TSP
 * SubProject : jTSP
 * Maintainer : tsp@astrium-space.com
 * Component  : 
 * 
 * -----------------------------------------------------------------------
 * 
 * Purpose   : Consumer
 * 
 * -----------------------------------------------------------------------
 */


package tsp.consumer.util.configuration;


import java.util.LinkedList;
import java.util.List;

import tsp.util.ToStringHelper;

public class SpecProviderList implements Consolidatable{

    private ImplicitProviderEnum implicitProvider;
    private final SpecSamplingConfig root;
    private LinkedList providers = new LinkedList();

    public SpecProviderList(final SpecSamplingConfig root) {
		super();
		this.root = root;
	}
    

    

    // Internal
    SpecProvider getLastProvider(){
        return (SpecProvider)providers.getLast();
    }

    void addLastProvider(SpecProvider l){        
        l.setProviderList(this);
    }

    // External

    public ImplicitProviderEnum getImplicitProvider() {
        return implicitProvider;
    }

    void setImplicitProvider(ImplicitProviderEnum implicitProvider) {
        this.implicitProvider = implicitProvider;
    }

    public List getProviders() {
        return providers;
    }


     public String toString(){
        return ToStringHelper.toString(this);
    }

     public void consolidate() throws SpecException {
		ConsolidatorHelper.Consolidate(providers);
	}


}
